unit U_GridSubdivisions_V1;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids;

type
  TForm1 = class(TForm)
    Grid1: TStringGrid;
    procedure FormActivate(Sender: TObject);
    procedure Grid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    Private
    Public  
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  DefVal: array[0..5,0..5] of integer =
         ((1,1,1,1,1,2),
          (1,1,1,2,2,2),
          (1,2,2,2,2,3),
          (1,4,5,5,5,3),
          (4,4,5,6,5,3),
          (4,4,6,6,3,3));


procedure TForm1.FormActivate(Sender: TObject);
var  {fill the grid with numbers representing the areas}
  r,c:integer;
begin
  for r:=0 to 5 do
  for c:=0 to 5 do
  grid1.cells[c,r]:=inttostr(defval[r,c]);
end;

{*********** GridDrawCell **************}
procedure TForm1.Grid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with grid1, canvas, rect do
  begin

    pen.width:=3; pen.color:=clblue;

    {Heavy left side line? Yes, if 1st column or left cell doesn't match}
    If  (acol=0) or
    ((acol>0) and (cells[acol,arow]<>cells[acol-1,arow]))
    then
    begin moveto(left,top); lineto(left,bottom); end;

    {Heavy top line?}
    If (arow=0) or
    ((arow>0) and (cells[acol,arow]<>cells[acol,arow-1]))
    then
    begin moveto(left,top); lineto(right,top); end;

     {Last column? Heavy right side line}
    if acol=colcount-1 then
    begin moveto(right,top); lineto(right,bottom); end;

    {Last row? Heavy bottom line}
    if arow=rowcount-1 then
    begin moveto(left,bottom); lineto(right,bottom); end;

    {DIsplay the figure #}
    textout(left+4, top+4,cells[acol,arow]);
  end;


  
end;

end.
